;get_element
; input:	hl - name of matrix excluding type byte
;		b  - desired row
;		c  - desired column
; output:	op1 - element
get_element:
_inc_ptr_ade	=$45ef
		push bc	;save row/col wanted
	rst 20h		;_mov10toOP1
	rst 10h		;_findsym
				;bde=variable data start
	ret c			;variable doesn't exist so
				; might as well quit now
	ld a,b			;_getmtoop1 needs ade as input
				; not bde
	call _inc_ptr_ade
	call _inc_ptr_ade	;get past size byte telling row/col
		pop bc		;get back row/col wanted
	jp _GetMtoOP1		;get element and exit
===============================
From: "David Phillips" <david@acz.org>
Subject: A86: Re: Quick question...

DispA:
 ld l,a
 ld h,0
DispHL:
 ld de,_OP1+5
 sub a
 ld (de),a
loop:
 dec de
 call _divHLby10
 add a,'0'
 ld (de),a
 ld a,h
 or l
 jr nz,loop
 jp _puts





StackSave = ...      ; somewhere free in ram, like _textShadow or something

 ld hl,0
 add hl,sp                    ; HL = SP
 ld (StackSave),hl        ; ah, I miss 16 bit loads...

...

ReturnToOSNoMatterWhereWeAre:
 ld hl,(StackSave)         ; get the stack pointer back
 ld sp,hl                        ; restore the stack pointer
 ret                               ; back to the OS!!!






;
;	input:	hl - number to display
;	output:	hl - original number
;		c - original l
;		d,e - destroyed by _vputmap
;
disp_hex_hl_m:
	ld a,h
	call disp_hex_a_m
	ld a,l
	;lead right into disp_hex_a_m

disp_hex_a_m:
	ld c,a				;save away a
	rrca \ rrca \ rrca \ rrca	;rotate a one nibble to right
					;%xxxxyyyy ->%yyyyxxxx
	and $0f				;only want bottom nibble
	call disp_nibble
	ld a,c
	and $0f
disp_nibble:
	add a,'0'
	cp '9'+1
	jr c,disp_nibble_now
	sub '9'+1-'a'
	jp _vputmap
disp_nibble_now:
	jp _vputmap
;


;
;	input:	a - number to display
;	output:	a - ascii hex
;		c - original a
;		d,e - destroyed by _vputmap
;
disp_hex_a_m:
	ld c,a				;save away a
	rrca \ rrca \ rrca \ rrca	;rotate a one nibble to right
					;%xxxxyyyy ->%yyyyxxxx
	and $0f				;only want bottom nibble
	call disp_nibble
	ld a,c
	and $0f
disp_nibble:
	add a,'0'
	cp '9'+1
	jr c,disp_nibble_now
	sub '9'+1-'a'
	jp _vputmap
disp_nibble_now:
	jp _vputmap
;

;
;	input:	a - number to display
;	output:	a - ascii of bit 0
;		c - original a
;		b - $00
;		d,e - destroyed by _vputmap
;
disp_bin_a_m:
	ld c,a
	ld b,8
disp_bin_a_m_loop:
	rl c
	jr c,disp_one
	ld a,'0'
	jr disp_it
disp_one:
	ld a,'1'
disp_it:
	call _vputmap
	djnz disp_bin_a_m_loop
	ret
;

;
;	input:	a - number to display
;	output:	a - ascii of first digit
;		b - $00
;		l - destroyed by _vputs
;	note:	need to define...
_divHLby10	=$4044
;		if using _OP6, change to some
;		 other temp storage area
;
disp_dec_a_m:
	ld h,0		;zero msb
	ld l,a		;load a into lsb
	ld de,_OP6	;temp storage area
	ld b,5		;5 digits max
disp_dec_a_m_loop1:
	call _divHLby10
	add a,'0'	;add ascii '0'
	dec de		;next mem space
	ld (de),a	;load it up
	djnz disp_dec_a_m_loop1

	ld b,4
	ld hl,_penCol
disp_dec_a_m_loop2:
	ld a,(de)	;get character
	cp '0'		;is it zero?
	jr nz,disp_dec_a_m_done
			;wasn't zero so
			; done searching for
			; first non zero
	inc de		;increase to next
			; character
	ld a,4
	add a,(hl)
	ld (hl),a
	djnz disp_dec_a_m_loop2
disp_dec_a_m_done:
	ex de,hl	;get back start of
			; string in hl
	jp _vputs
;